<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>objects</title>
</head>

<body>
    <script>

        const mustHave = ["nombre", "id", "fabricante"]

        var tvSamsung = {
            nombre: "TV Samsung 42",
            categoria: "Televisores",
            unidades: "4",
            precio: "345.95",
        }

        function getImporte() {
            return this.unidades * this.precio;
        }
        function createNewProperties() {
            for (let index = 0; index < 3; index++) {
                let newPrroperty = prompt("new Property");
                let propertyValue = prompt("value");
                this[newPrroperty] = propertyValue;
            }
            return true;
        }

        function checkMustHaveProperties(tvSamsung) {
            for (const property of mustHave) {
                if (!(property in tvSamsung)) {
                    tvSamsung[property] = undefined;
                }
            }
            return true;
        }

        function printObjectHTML(tvSamsung) {
            for (const property in tvSamsung) {
                let newP = document.createElement("p");
                let newPText = document.createTextNode(property + " --> " + tvSamsung[property]);
                newP.appendChild(newPText);
                document.body.appendChild(newP);
            }
            return true;
        }

        function stringifyObject(tvSamsung) {
            let newJson = JSON.stringify(tvSamsung);
            return newJson;
        }

        function parseJson(tvSamsung) {
            let newObject = JSON.parse(tvSamsung);
            return newObject;
        }

        //createNewProperties(tvSamsung);
        checkMustHaveProperties(tvSamsung);
        printObjectHTML(tvSamsung);
        console.log(stringifyObject(tvSamsung));

        console.log(parseJson(stringifyObject(tvSamsung)));



    </script>
</body>

</html>